/*
 *  flop.c
 */

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

#include "ext.h"
#include "ext_obex.h"

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

typedef struct _flop {
	t_object	ob;
	long		toto;
	long		momo;
	long		jojo;
	void		*leftOutlet;
	} t_flop;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

void		*flop_new		(t_symbol *s, long argc, t_atom *argv);
void		flop_free		(t_flop *x);
void		flop_assist		(t_flop *x, void *b, long m, long a, char *s);

void		flop_bang		(t_flop *x);

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -
		
static t_class *flop_class;

int main (void)
{	
	t_class *c = NULL;
	
	c = class_new ("flop", (method)flop_new, (method)flop_free, (long)sizeof(t_flop), 0L, A_GIMME, 0);
	
	class_addmethod	(c, (method)flop_assist,	"assist", A_CANT, 0);
	class_addmethod (c, (method)flop_bang,		"bang", 0);

	CLASS_ATTR_LONG				(c, "toto", ATTR_SET_OPAQUE, t_flop, toto);			
	CLASS_ATTR_STYLE_LABEL		(c, "toto", 0, "enumindex", "Toto");	
	CLASS_ATTR_ENUMINDEX		(c, "toto", 0, "\"Off\" \"On\"");	
	CLASS_ATTR_FILTER_CLIP		(c, "toto", 0, 1);
	CLASS_ATTR_SAVE				(c,	"toto", 0);	

	CLASS_ATTR_LONG				(c, "jojo", ATTR_SET_OPAQUE_USER, t_flop, jojo);			
	CLASS_ATTR_STYLE_LABEL		(c, "jojo", 0, "enumindex", "Jojo");	
	CLASS_ATTR_ENUMINDEX		(c, "jojo", 0, "\"Off\" \"On\"");	
	CLASS_ATTR_FILTER_CLIP		(c, "jojo", 0, 1);
	CLASS_ATTR_SAVE				(c,	"jojo", 0);	
	
	CLASS_ATTR_LONG				(c, "momo", 0, t_flop, momo);			
	CLASS_ATTR_STYLE_LABEL		(c, "momo", 0, "enumindex", "Momo");	
	CLASS_ATTR_ENUMINDEX		(c, "momo", 0, "\"Off\" \"On\"");	
	CLASS_ATTR_FILTER_CLIP		(c, "momo", 0, 1);
	CLASS_ATTR_SAVE				(c,	"momo", 0);	
	
	class_register (CLASS_BOX, c);
	
	flop_class = c;
	
	return 0;
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

void *flop_new (t_symbol *s, long argc, t_atom *argv)
{
	t_flop *x = NULL;
	
	if (x = (t_flop *)object_alloc (flop_class)) 
		{	
			x->leftOutlet = bangout ((t_object *)x);
			
			attr_args_process (x, argc, argv);
		}			
		
	return x;
}

void flop_free (t_flop *x)
{ 
	;
}

void flop_assist (t_flop *x, void *b, long m, long a, char *s)
{
	if (m == ASSIST_INLET) 
		{ 
			sprintf (s, "(bang)");
		} 
	else 
		{	
			sprintf (s, "bang !");
		}
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

void flop_bang (t_flop *x) 
{ 
	outlet_bang (x->leftOutlet);
}

// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x